Loading...
Searching...
No Matches
BALL::GAMESSLogFile Class Reference
Molecular Modeling » File Formats » Molecular structure file formats

`#include <BALL/FORMAT/GAMESSLogFile.h>`

Inheritance diagram for BALL::GAMESSLogFile:

## Classes

struct | State

## Public Member Functions

Constructors and Destructors
| GAMESSLogFile ()
| GAMESSLogFile (const GAMESSLogFile &file)
| GAMESSLogFile (const String &filename, File::OpenMode open_mode=std::ios::in)
virtual | ~GAMESSLogFile ()
Assignment.
const GAMESSLogFile & | operator= (const GAMESSLogFile &rhs)
Reading and Writing of Kernel Logastructures
virtual bool | write (const Molecule &molecule)
virtual bool | write (const System &molecule)
virtual Molecule * | read ()
virtual bool | read (System &system)
Public Member Functions inherited from BALL::GenericMolFile
| GenericMolFile ()
| GenericMolFile (const String &filename, File::OpenMode open_mode=std::ios::in)
virtual | ~GenericMolFile ()
virtual void | close ()
const GenericMolFile & | operator= (const GenericMolFile &rhs)
void | defineInputAsTemporary (bool b=true)
void | enableOutputCompression (String zipped_filename)
bool | isCompressedFile ()
virtual GenericMolFile & | operator>> (System &system)
virtual GenericMolFile & | operator<< (const System &system)
virtual GenericMolFile & | operator>> (Molecule &molecule)
virtual GenericMolFile & | operator<< (const Molecule &molecule)
Public Member Functions inherited from BALL::LineBasedFile
| LineBasedFile ()
| Default constructor.
| LineBasedFile (const String &filename, File::OpenMode open_mode=std::ios::in, bool trim_whitespaces=false)
void | clear ()
bool | operator== (const LineBasedFile &f)
bool | operator!= (const LineBasedFile &f)
const LineBasedFile & | operator= (const LineBasedFile &file)
Position | getLineNumber () const
| Get the last line number in the file.
const String & | getLine () const
| Return the current line.
String & | getLine ()
| Return the current line.
bool | readLine ()
bool | skipLines (Size number=1)
bool | search (const String &text, bool return_to_start=false)
bool | search (const String &text, const String &stop, bool return_to_start=false)
bool | gotoLine (Position line_number)
void | rewind ()
void | test (const char *file, int line, bool condition, const String &msg) const
String | getField (Index pos=0, const String &quotes="", const String &delimiters=String::CHARACTER_CLASS__WHITESPACE) const
bool | startsWith (const String &text) const
| Test if the current line starts with text.
bool | has (const String &text) const
| Return true if the current line contains text.
Index | switchString (const std::vector< String > &data) const
bool | parseColumnFormat (const char *format, Position index, Size length, void *arg)
void | enableTrimWhitespaces (bool state)
| Set wheter leading and trailing whitespaces in lines shall be removed.
bool | trimWhiteSpacesEnabled () const
Public Member Functions inherited from BALL::File
| File ()
| File (const String &name, OpenMode open_mode=std::ios::in)
virtual | ~File ()
bool | isValid () const
bool | open (const String &name, File::OpenMode open_mode=std::ios::in)
bool | reopen ()
bool | reopen (File::OpenMode open_mode)
void | close ()
const String & | getName () const
void | setName (const String &name)
const String & | getOriginalName () const
Size | getSize ()
File::OpenMode | getOpenMode () const
Type | getType (bool trace_link) const
bool | copyTo (const String &destination_name, Size buffer_size=4096)
bool | moveTo (const String &destination_name)
bool | remove ()
bool | renameTo (const String &new_path)
bool | truncate (Size size=0)
std::fstream & | getFileStream ()
TransformationManager & | getTransformationManager ()
const TransformationManager & | getTransformationManager () const
bool | operator== (const File &file) const
bool | operator!= (const File &file) const
bool | isOpen () const
bool | isClosed () const
bool | isAccessible () const
bool | isCanonized () const
bool | isReadable () const
bool | isWritable () const
bool | isExecutable () const

## Accessors

static State | state
Index | current_atom
Index | current_set
Index | current_coefficient_line
Size | basis_size
bool | molecule_already_defined
System * | system
Molecule * | molecule_
float | factor_
splitValenceSet | qmbs_
StringHashMap< String > | basis_options_
void | newMolecule ()
void | setMoleculeName (char *name)
void | insertAtom (const String &element, float charge, float x, float y, float z)
void | insertBond (Index a1, Index a2)
void | clearBonds ()
void | setCurrentCharge (float charge)
void | setUnitConversionFactor (float factor)
void | addCoefficient (float coefficient)
void | initializeBasisSet ()
QMBasisSet & | getBasisSet ()
const QMBasisSet & | getBasisSet () const
void | addBasisOption (const String &key, const String &value)
String | getBasisOption (const String &key)
virtual void | initRead_ ()

## Additional Inherited Members

Public Types inherited from BALL::File
typedef std::ios::openmode | OpenMode
enum | Transformation { TRANSFORMATION__EXEC = 1 , TRANSFORMATION__FILTER = 2 , TRANSFORMATION__URL = 3 }
enum | Type { TYPE__UNKNOWN = 0 , TYPE__DIRECTORY = 1 , TYPE__CHAR_SPECIAL_FILE = 2 , TYPE__BLOCK_SPECIAL_FILE = 3 , TYPE__REGULAR_FILE = 4 , TYPE__SYMBOLIC_LINK = 5 , TYPE__SOCKET = 6 , TYPE__FIFO_SPECIAL_FILE = 7 }
static Size | getSize (String name)
static Type | getType (String name, bool trace_link)
static bool | copy (String source_name, String destination_name, Size buffer_size=4096)
static bool | move (const String &source_name, const String &destination_name)
static bool | remove (String name)
static bool | rename (String old_path, String new_path)
static bool | truncate (String path, Size size=0)
static bool | createTemporaryFilename (String &temporary, const String &suffix=".TMP")
static void | enableTransformation (Transformation transformation)
static void | disableTransformation (Transformation transformation)
static bool | isTransformationEnabled (Transformation transformation)
static void | registerTransformation (const String &pattern, const String &exec)
static void | unregisterTransformation (const String &pattern)
static bool | isAccessible (String name)
static bool | isReadable (String name)
static bool | isWritable (String name)
static bool | isExecutable (String name)
Static Public Attributes inherited from BALL::File
static const OpenMode | MODE_IN
| Open for input (default).
static const OpenMode | MODE_OUT
| Open for output.
static const OpenMode | MODE_APP
| Append. Seek to end before each write operation.
static const OpenMode | MODE_BINARY
| Binary mode.
static const OpenMode | MODE_ATE
| Seek to end directly after opening.
static const OpenMode | MODE_TRUNC
| Truncate an existing file.
static const String | TRANSFORMATION_EXEC_PREFIX
| Prefix for filenames that are created through the execution of commands "exec:".
static const String | TRANSFORMATION_FILE_PREFIX
| Prefix for files (to mimick URL-like behavior) "file:".
static const String | TRANSFORMATION_FTP_PREFIX
| Prefix for FTP-transfers "ftp://".
static const String | TRANSFORMATION_HTTP_PREFIX
| Prefix for HTTP-transfer "http://".
virtual void | initWrite_ ()
bool | input_is_temporary_
bool | compress_output_
bool | gmf_is_closed_
String | zipped_filename_
String | line_
| buffer for the line in use
Position | line_number_
| line number in the file
bool | trim_whitespaces_
vector< char > | col_buffer_
| buffer for column parsing
String | name_
String | original_name_
OpenMode | open_mode_
bool | is_open_
bool | is_temporary_
static HashSet< String > | created_temp_filenames_
static TransformationManager | transformation_manager_
static Size | transformation_methods_

## Detailed Description

GAMESSLog file class. This class enables BALL to read and write input and output .log files for the GAMESS quantum chemistry application.

Definition at line 28 of file GAMESSLogFile.h.

## Constructor & Destructor Documentation

## GAMESSLogFile() [1/3]

BALL::GAMESSLogFile::GAMESSLogFile | ( |  | ) |

Default constructor

## GAMESSLogFile() [2/3]

BALL::GAMESSLogFile::GAMESSLogFile | ( | const GAMESSLogFile & | file | ) |

Copy constructor

Exceptions

  Exception::FileNotFound | if the file could not be opened

## GAMESSLogFile() [3/3]

BALL::GAMESSLogFile::GAMESSLogFile | ( | const String & | filename,
|  | File::OpenMode | open_mode = std::ios::in )

Detailed constructor

Exceptions

  Exception::FileNotFound | if the file could not be opened

## ~GAMESSLogFile()

virtual BALL::GAMESSLogFile::~GAMESSLogFile | ( |  | ) |

virtual

Destructor

## Member Function Documentation

## addBasisOption()

void BALL::GAMESSLogFile::addBasisOption | ( | const String & | key,
|  | const String & | value )

## addCoefficient()

void BALL::GAMESSLogFile::addCoefficient | ( | float | coefficient | ) |

## clearBonds()

void BALL::GAMESSLogFile::clearBonds | ( |  | ) |

## getBasisOption()

String BALL::GAMESSLogFile::getBasisOption | ( | const String & | key | ) |

## getBasisSet() [1/2]

QMBasisSet & BALL::GAMESSLogFile::getBasisSet | ( |  | ) |

## getBasisSet() [2/2]

const QMBasisSet & BALL::GAMESSLogFile::getBasisSet | ( |  | ) | const

## initializeBasisSet()

void BALL::GAMESSLogFile::initializeBasisSet | ( |  | ) |

## initRead_()

virtual void BALL::GAMESSLogFile::initRead_ | ( |  | ) |

protected virtual

Initialize internals for read. This method is called by the default implementation of read(System& system) . Its purpose is the initialization of internal members holding, for example, header information from the file. The default implementation provided is empty.

Reimplemented from BALL::GenericMolFile.

## insertAtom()

void BALL::GAMESSLogFile::insertAtom | ( | const String & | element,
|  | float | charge,
|  | float | x,
|  | float | y,
|  | float | z )

## insertBond()

void BALL::GAMESSLogFile::insertBond | ( | Index | a1,
|  | Index | a2 )

## newMolecule()

void BALL::GAMESSLogFile::newMolecule | ( |  | ) |

## operator=()

const GAMESSLogFile & BALL::GAMESSLogFile::operator= | ( | const GAMESSLogFile & | rhs | ) |

Assignment operator.

Exceptions

  Exception::FileNotFound | if the file could not be opened

## read() [1/2]

virtual Molecule * BALL::GAMESSLogFile::read | ( |  | ) |

virtual

Read a Molecule from the GAMESSLogFile. If the GAMESS .log - file contains additional lines apart from the molecule itself, they are stored in this class.

Exceptions

  Exception::ParseError | if a syntax error was encountered

Reimplemented from BALL::GenericMolFile.

## read() [2/2]

virtual bool BALL::GAMESSLogFile::read | ( | System & | system | ) |

virtual

Read a System from the GAMESSLogFile. If the GAMESS .log - file contains additional lines apart from the molecule itself, they are stored in this class.

Exceptions

  Exception::ParseError | if a syntax error was encountered

Reimplemented from BALL::GenericMolFile.

## setCurrentCharge()

void BALL::GAMESSLogFile::setCurrentCharge | ( | float | charge | ) |

## setMoleculeName()

void BALL::GAMESSLogFile::setMoleculeName | ( | char * | name | ) |

## setUnitConversionFactor()

void BALL::GAMESSLogFile::setUnitConversionFactor | ( | float | factor | ) |

## write() [1/2]

virtual bool BALL::GAMESSLogFile::write | ( | const Molecule & | molecule | ) |

virtual

Write a molecule to a GAMESSLogFile. If additional GAMESS - keywords are stored in this class, they will be written as well.

Exceptions

  File::CannotWrite | if writing to the file failed

Reimplemented from BALL::GenericMolFile.

## write() [2/2]

virtual bool BALL::GAMESSLogFile::write | ( | const System & | molecule | ) |

virtual

Write a system to a GAMESSLogFile. If additional GAMESS - keywords are stored in this class, they will be written as well.

Exceptions

  File::CannotWrite | if writing to the file failed

Reimplemented from BALL::GenericMolFile.

## Member Data Documentation

## basis_options_

StringHashMap<String> BALL::GAMESSLogFile::basis_options_

protected

Definition at line 160 of file GAMESSLogFile.h.

## basis_size

Size BALL::GAMESSLogFile::basis_size

Definition at line 143 of file GAMESSLogFile.h.

## current_atom

Index BALL::GAMESSLogFile::current_atom

Definition at line 140 of file GAMESSLogFile.h.

## current_coefficient_line

Index BALL::GAMESSLogFile::current_coefficient_line

Definition at line 142 of file GAMESSLogFile.h.

## current_set

Index BALL::GAMESSLogFile::current_set

Definition at line 141 of file GAMESSLogFile.h.

## factor_

float BALL::GAMESSLogFile::factor_

protected

Definition at line 156 of file GAMESSLogFile.h.

## molecule_

Molecule* BALL::GAMESSLogFile::molecule_

protected

Definition at line 155 of file GAMESSLogFile.h.

## molecule_already_defined

bool BALL::GAMESSLogFile::molecule_already_defined

Definition at line 144 of file GAMESSLogFile.h.

## qmbs_

splitValenceSet BALL::GAMESSLogFile::qmbs_

protected

Definition at line 158 of file GAMESSLogFile.h.

## state

State BALL::GAMESSLogFile::state

static

Definition at line 139 of file GAMESSLogFile.h.

## system

System* BALL::GAMESSLogFile::system

All of this stuff should not really be placed here... we need a data structure for QM data sets that stores all the stuff here.

Definition at line 150 of file GAMESSLogFile.h.